#ifndef __CHECKER_H__
#define __CHECKER_H__

#include "Graph.h"
#include <string>
#include <iostream>



string fileName = "date.in";




void VerifyBackArcs(vector<Node*> order) {
	Graph graph(fileName);
	if ( order.size() != graph.nrNodes ){
		cout << "Error: No order received!\n";
		return;
	}
		
	for(int index = 0; index < order.size(); index++) {
			
		int currentNodeId = order.at(index)->getId();
		Node* currentNode = graph.getNodeWithId(currentNodeId);
			
		for(int previousIndex = 0; previousIndex < index; previousIndex++){
				
			int previousId = order.at(previousIndex)->getId();
			Node* previousNode =  graph.getNodeWithId(previousId);
			vector<Node*> outNodes = currentNode->getOutNodes();
			for (vector<Node*>::iterator it = outNodes.begin(); it != outNodes.end(); ++it){
				if ( (*it)->getId() == previousNode->getId() ){
					cout << "Error: " << (*it)->getId() << " <- " << currentNode->getId()  << "\n";
					return;
				}
			}

		}
	}
	cout << "Success\n";
	return;
}

void VerifySolution(vector<Node*> order, string method) {
	cout << "[" << method << "] ";
	VerifyBackArcs(order);
}
#endif